package com.contextspace.objectdb_example.model;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.ElementCollection;
import javax.persistence.Embedded;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToMany;
import javax.persistence.Table;


/**
 * Creation Details:
 * @author pedwards
 * Created: 16/04/2012
 * Time: 1:20:59 PM
 */
@Table
@Entity
public class Rule extends IDHolder {

    private static final long serialVersionUID = 1L;
    private String name = null;
    
    List<RulePart> rules = new ArrayList<RulePart>();
    
    private String compiledRule = null;

    /**
     * Default Constructor
     */
    public Rule() {
        
    }
    
    /**
     * Constructor
     * @param name
     */
    public Rule(String name) {
        this.name = name;
    }
    
    /**
     * @return the name
     */
    public String getName() {
        return name;
    }

    /**
     * @param name the name to set
     */
    public void setName(String name) {
        this.name = name;
    }

    /**
     * @return the rules
     */
    @ElementCollection
    //@OneToMany(cascade=CascadeType.ALL, fetch=FetchType.EAGER, orphanRemoval=true)
    public List<RulePart> getRules() {
        return rules;
    }

    /**
     * @param rules the rules to set
     */
    public void setRules(List<RulePart> rules) {
        this.rules = rules;
    }
    
    /**
     * Add rulePart
     * @param newPart
     */
    public void addRulePart(RulePart newPart) {
        this.rules.add(newPart);
    }

    /**
     * @return the compiledRule
     */
    public String getCompiledRule() {
        return compiledRule;
    }

    /**
     * @param compiledRule the compiledRule to set
     */
    public void setCompiledRule(String compiledRule) {
        this.compiledRule = compiledRule;
    }
}
